"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
var faker = __importStar(require("faker"));
var test_utils_1 = require("./test-utils");
var book_1 = require("./sample/entities/book");
describe('entity-factory', function () {
    var bookFactory;
    var orm;
    var em;
    var container;
    beforeAll(function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, test_utils_1.getConnectionOrm()];
                case 1:
                    orm = _a.sent();
                    return [4 /*yield*/, test_utils_1.loadSchema(orm)];
                case 2:
                    _a.sent();
                    em = orm.em;
                    return [4 /*yield*/, test_utils_1.getContainer(em)];
                case 3:
                    container = _a.sent();
                    bookFactory = container.getFactory(book_1.Book);
                    return [2 /*return*/];
            }
        });
    }); });
    afterEach(function () { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
        return [2 /*return*/, test_utils_1.clearDB(em)];
    }); }); });
    afterAll(function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, test_utils_1.clearDB(em)];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, orm.isConnected()];
                case 2:
                    if (!_a.sent()) return [3 /*break*/, 4];
                    return [4 /*yield*/, orm.close()];
                case 3:
                    _a.sent();
                    _a.label = 4;
                case 4: return [2 /*return*/];
            }
        });
    }); });
    describe('saveOne()', function () {
        describe('bookFactory', function () {
            it('can bulk instantiate entities', function () { return __awaiter(void 0, void 0, void 0, function () {
                var book, _a, savedBooks, savedBooksCount, savedBooks_1, savedBooks_1_1, savedBook;
                var e_1, _b;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0: return [4 /*yield*/, bookFactory.saveOne()];
                        case 1:
                            book = _c.sent();
                            expect(book.id).toBeDefined();
                            expect(book.title).toBeDefined();
                            expect(book.genre).toBeDefined();
                            return [4 /*yield*/, em.findAndCount(book_1.Book, {}, {
                                    populate: ['genre'],
                                })];
                        case 2:
                            _a = __read.apply(void 0, [_c.sent(), 2]), savedBooks = _a[0], savedBooksCount = _a[1];
                            /** Check that the database has been updated with the new book */
                            expect(savedBooksCount).toBe(1);
                            expect(savedBooksCount).toEqual(savedBooks.length);
                            try {
                                for (savedBooks_1 = __values(savedBooks), savedBooks_1_1 = savedBooks_1.next(); !savedBooks_1_1.done; savedBooks_1_1 = savedBooks_1.next()) {
                                    savedBook = savedBooks_1_1.value;
                                    expect(savedBook.id).toBeDefined();
                                    expect(savedBook.title).toBeDefined();
                                    expect(savedBook.genre).toBeDefined();
                                }
                            }
                            catch (e_1_1) { e_1 = { error: e_1_1 }; }
                            finally {
                                try {
                                    if (savedBooks_1_1 && !savedBooks_1_1.done && (_b = savedBooks_1.return)) _b.call(savedBooks_1);
                                }
                                finally { if (e_1) throw e_1.error; }
                            }
                            return [2 /*return*/];
                    }
                });
            }); });
            it('can instantiate a book with partial parameters', function () { return __awaiter(void 0, void 0, void 0, function () {
                var BOOK_TITLE, BOOK_COUNT, book, _a, savedBooks, count;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            BOOK_TITLE = faker.random.words();
                            BOOK_COUNT = 10;
                            return [4 /*yield*/, bookFactory.saveOne({
                                    title: BOOK_TITLE,
                                })];
                        case 1:
                            book = _b.sent();
                            return [4 /*yield*/, bookFactory.saveMany(10, {
                                    title: BOOK_TITLE,
                                })];
                        case 2:
                            _b.sent();
                            expect(book).toBeDefined();
                            expect(book.title).toEqual(BOOK_TITLE);
                            return [4 /*yield*/, em.findAndCount(book_1.Book, {
                                    title: BOOK_TITLE,
                                })];
                        case 3:
                            _a = __read.apply(void 0, [_b.sent(), 2]), savedBooks = _a[0], count = _a[1];
                            expect(count).toBe(BOOK_COUNT + 1);
                            savedBooks.forEach(function (savedBook) {
                                expect(savedBook).not.toBeNull();
                                expect(savedBook.title).toEqual(BOOK_TITLE);
                            });
                            return [2 /*return*/];
                    }
                });
            }); });
        });
    });
    describe('saveMany()', function () {
        describe('bookFactory', function () {
            it('can bulk instantiate entities', function () { return __awaiter(void 0, void 0, void 0, function () {
                var BOOKS_COUNT, books, _a, savedBooks, savedBooksCount, savedBooks_2, savedBooks_2_1, book;
                var e_2, _b;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            BOOKS_COUNT = 100;
                            return [4 /*yield*/, bookFactory.saveMany(BOOKS_COUNT)];
                        case 1:
                            books = _c.sent();
                            /** Instantiate a large amount of books */
                            expect(books.length).toBe(BOOKS_COUNT);
                            books.forEach(function (book) {
                                expect(book.id).toBeDefined();
                                expect(book.title).toBeDefined();
                            });
                            return [4 /*yield*/, em.findAndCount(book_1.Book, {})];
                        case 2:
                            _a = __read.apply(void 0, [_c.sent(), 2]), savedBooks = _a[0], savedBooksCount = _a[1];
                            /** Check that the saved books are saved and defined */
                            expect(savedBooksCount).toEqual(BOOKS_COUNT);
                            expect(savedBooksCount).toEqual(savedBooks.length);
                            try {
                                for (savedBooks_2 = __values(savedBooks), savedBooks_2_1 = savedBooks_2.next(); !savedBooks_2_1.done; savedBooks_2_1 = savedBooks_2.next()) {
                                    book = savedBooks_2_1.value;
                                    expect(book.id).toBeDefined();
                                    expect(book.title).toBeDefined();
                                }
                            }
                            catch (e_2_1) { e_2 = { error: e_2_1 }; }
                            finally {
                                try {
                                    if (savedBooks_2_1 && !savedBooks_2_1.done && (_b = savedBooks_2.return)) _b.call(savedBooks_2);
                                }
                                finally { if (e_2) throw e_2.error; }
                            }
                            return [2 /*return*/];
                    }
                });
            }); });
        });
    });
});
