import { EntityFactory } from '../../../entity-factory';
import { Genre } from '../entities/genre';
export declare class GenreFactory extends EntityFactory<Genre> {
    /**
     * @inheritdoc
     * Create a Genre with default parameters
     * @returns a stubbed Genre
     */
    make(): Promise<Genre>;
}
